Exec { timeout => 300 }

package{['nagios', 'nagios-plugins-nrpe', 'nagios-plugins-ping']:
    ensure => present,
    before => Class['nagios_configs']
}

class nagios_configs(){
    file{['/etc/nagios/nagios_command.cfg', '/etc/nagios/nagios_host.cfg']:
        ensure => 'present',
        mode => '0644',
        owner => 'nagios',
        group => 'nagios',
    }

    # Remove the entry for localhost, it contains services we're not
    # monitoring
    file{['/etc/nagios/objects/localhost.cfg']:
        ensure => 'present',
        content => '',
    }

    file_line{'nagios_host':
        path => '/etc/nagios/nagios.cfg',
        line => 'cfg_file=/etc/nagios/nagios_host.cfg',
    }

    file_line{'nagios_command':
        path => '/etc/nagios/nagios.cfg',
        line => 'cfg_file=/etc/nagios/nagios_command.cfg',
    }

    file_line{'nagios_service':
        path => '/etc/nagios/nagios.cfg',
        line => 'cfg_file=/etc/nagios/nagios_service.cfg',
    }

    nagios_command{'check_nrpe':
        command_line => '/usr/lib64/nagios/plugins/check_nrpe -H $HOSTADDRESS$ -c $ARG1$',
    }

    exec{'nagiospasswd':
        command => '/usr/bin/htpasswd -b /etc/nagios/passwd nagiosadmin badpass',
    }

    file {"/etc/nagios/keystonerc_admin":
        ensure  => "present", owner  => "nagios", mode => '0600',
        content => "export OS_USERNAME=admin
export OS_TENANT_NAME=admin
export OS_PASSWORD=badpass
export OS_AUTH_URL=http://10.16.139.4:35357/v2.0/ ",}

    nagios_host { '10.16.139.4': , use => 'linux-server', address => '10.16.139.4'}
nagios_host { '10.16.139.8': , use => 'linux-server', address => '10.16.139.8'}
nagios_host { '10.16.139.3': , use => 'linux-server', address => '10.16.139.3'}
nagios_host { '10.16.139.37': , use => 'linux-server', address => '10.16.139.37'}
nagios_host { '10.16.139.10': , use => 'linux-server', address => '10.16.139.10'}
nagios_host { '10.16.139.31': , use => 'linux-server', address => '10.16.139.31'}
nagios_host { '10.16.139.7': , use => 'linux-server', address => '10.16.139.7'}
nagios_host { '10.16.139.6': , use => 'linux-server', address => '10.16.139.6'}
nagios_host { '10.16.139.2': , use => 'linux-server', address => '10.16.139.2'}
nagios_host { '10.16.139.9': , use => 'linux-server', address => '10.16.139.9'}
nagios_host { '10.16.139.5': , use => 'linux-server', address => '10.16.139.5'}
nagios_host { '10.16.139.36': , use => 'linux-server', address => '10.16.139.36'}
nagios_host { '10.16.139.38': , use => 'linux-server', address => '10.16.139.38'}
nagios_host { '10.16.139.39': , use => 'linux-server', address => '10.16.139.39'}
file{"/usr/lib64/nagios/plugins/keystone-user-list":mode => 755, owner => "nagios", seltype => "nagios_unconfined_plugin_exec_t", content => template("packstack/keystone-user-list.erb"),}
nagios_command {"keystone-user-list": command_line => "/usr/lib64/nagios/plugins/keystone-user-list",}
file{"/usr/lib64/nagios/plugins/glance-index":mode => 755, owner => "nagios", seltype => "nagios_unconfined_plugin_exec_t", content => template("packstack/glance-index.erb"),}
nagios_command {"glance-index": command_line => "/usr/lib64/nagios/plugins/glance-index",}
file{"/usr/lib64/nagios/plugins/nova-list":mode => 755, owner => "nagios", seltype => "nagios_unconfined_plugin_exec_t", content => template("packstack/nova-list.erb"),}
nagios_command {"nova-list": command_line => "/usr/lib64/nagios/plugins/nova-list",}
file{"/usr/lib64/nagios/plugins/cinder-list":mode => 755, owner => "nagios", seltype => "nagios_unconfined_plugin_exec_t", content => template("packstack/cinder-list.erb"),}
nagios_command {"cinder-list": command_line => "/usr/lib64/nagios/plugins/cinder-list",}
file { '/etc/nagios/nagios_service.cfg': 
ensure => present, mode => 644,
owner => 'nagios', group => 'nagios',
before => Service['nagios'],
content => 'define service {
	check_command	check_nrpe!load5
	host_name	10.16.139.4
	name	load5-10.16.139.4
	normal_check_interval	5
	service_description	5 minute load average
	use	generic-service
	}
define service {
	check_command	check_nrpe!df_var
	host_name	10.16.139.4
	name	df_var-10.16.139.4
	service_description	Percent disk space used on /var
	use	generic-service
	}
define service {
	check_command	check_nrpe!load5
	host_name	10.16.139.8
	name	load5-10.16.139.8
	normal_check_interval	5
	service_description	5 minute load average
	use	generic-service
	}
define service {
	check_command	check_nrpe!df_var
	host_name	10.16.139.8
	name	df_var-10.16.139.8
	service_description	Percent disk space used on /var
	use	generic-service
	}
define service {
	check_command	check_nrpe!load5
	host_name	10.16.139.3
	name	load5-10.16.139.3
	normal_check_interval	5
	service_description	5 minute load average
	use	generic-service
	}
define service {
	check_command	check_nrpe!df_var
	host_name	10.16.139.3
	name	df_var-10.16.139.3
	service_description	Percent disk space used on /var
	use	generic-service
	}
define service {
	check_command	check_nrpe!load5
	host_name	10.16.139.37
	name	load5-10.16.139.37
	normal_check_interval	5
	service_description	5 minute load average
	use	generic-service
	}
define service {
	check_command	check_nrpe!df_var
	host_name	10.16.139.37
	name	df_var-10.16.139.37
	service_description	Percent disk space used on /var
	use	generic-service
	}
define service {
	check_command	check_nrpe!load5
	host_name	10.16.139.10
	name	load5-10.16.139.10
	normal_check_interval	5
	service_description	5 minute load average
	use	generic-service
	}
define service {
	check_command	check_nrpe!df_var
	host_name	10.16.139.10
	name	df_var-10.16.139.10
	service_description	Percent disk space used on /var
	use	generic-service
	}
define service {
	check_command	check_nrpe!load5
	host_name	10.16.139.31
	name	load5-10.16.139.31
	normal_check_interval	5
	service_description	5 minute load average
	use	generic-service
	}
define service {
	check_command	check_nrpe!df_var
	host_name	10.16.139.31
	name	df_var-10.16.139.31
	service_description	Percent disk space used on /var
	use	generic-service
	}
define service {
	check_command	check_nrpe!load5
	host_name	10.16.139.7
	name	load5-10.16.139.7
	normal_check_interval	5
	service_description	5 minute load average
	use	generic-service
	}
define service {
	check_command	check_nrpe!df_var
	host_name	10.16.139.7
	name	df_var-10.16.139.7
	service_description	Percent disk space used on /var
	use	generic-service
	}
define service {
	check_command	check_nrpe!load5
	host_name	10.16.139.6
	name	load5-10.16.139.6
	normal_check_interval	5
	service_description	5 minute load average
	use	generic-service
	}
define service {
	check_command	check_nrpe!df_var
	host_name	10.16.139.6
	name	df_var-10.16.139.6
	service_description	Percent disk space used on /var
	use	generic-service
	}
define service {
	check_command	check_nrpe!load5
	host_name	10.16.139.2
	name	load5-10.16.139.2
	normal_check_interval	5
	service_description	5 minute load average
	use	generic-service
	}
define service {
	check_command	check_nrpe!df_var
	host_name	10.16.139.2
	name	df_var-10.16.139.2
	service_description	Percent disk space used on /var
	use	generic-service
	}
define service {
	check_command	check_nrpe!load5
	host_name	10.16.139.9
	name	load5-10.16.139.9
	normal_check_interval	5
	service_description	5 minute load average
	use	generic-service
	}
define service {
	check_command	check_nrpe!df_var
	host_name	10.16.139.9
	name	df_var-10.16.139.9
	service_description	Percent disk space used on /var
	use	generic-service
	}
define service {
	check_command	check_nrpe!load5
	host_name	10.16.139.5
	name	load5-10.16.139.5
	normal_check_interval	5
	service_description	5 minute load average
	use	generic-service
	}
define service {
	check_command	check_nrpe!df_var
	host_name	10.16.139.5
	name	df_var-10.16.139.5
	service_description	Percent disk space used on /var
	use	generic-service
	}
define service {
	check_command	check_nrpe!load5
	host_name	10.16.139.36
	name	load5-10.16.139.36
	normal_check_interval	5
	service_description	5 minute load average
	use	generic-service
	}
define service {
	check_command	check_nrpe!df_var
	host_name	10.16.139.36
	name	df_var-10.16.139.36
	service_description	Percent disk space used on /var
	use	generic-service
	}
define service {
	check_command	check_nrpe!load5
	host_name	10.16.139.38
	name	load5-10.16.139.38
	normal_check_interval	5
	service_description	5 minute load average
	use	generic-service
	}
define service {
	check_command	check_nrpe!df_var
	host_name	10.16.139.38
	name	df_var-10.16.139.38
	service_description	Percent disk space used on /var
	use	generic-service
	}
define service {
	check_command	check_nrpe!load5
	host_name	10.16.139.39
	name	load5-10.16.139.39
	normal_check_interval	5
	service_description	5 minute load average
	use	generic-service
	}
define service {
	check_command	check_nrpe!df_var
	host_name	10.16.139.39
	name	df_var-10.16.139.39
	service_description	Percent disk space used on /var
	use	generic-service
	}
define service {
	check_command	keystone-user-list
	host_name	10.16.139.31
	name	keystone-user-list
	normal_check_interval	5
	service_description	number of keystone users
	use	generic-service
	}
define service {
	check_command	glance-index
	host_name	10.16.139.31
	name	glance-index
	normal_check_interval	5
	service_description	number of glance images
	use	generic-service
	}
define service {
	check_command	nova-list
	host_name	10.16.139.31
	name	nova-list
	normal_check_interval	5
	service_description	number of nova vm instances
	use	generic-service
	}
define service {
	check_command	cinder-list
	host_name	10.16.139.31
	name	cinder-list
	normal_check_interval	5
	service_description	number of cinder volumes
	use	generic-service
	}
'}
}

class{'nagios_configs':
    notify => [Service['nagios'], Service['httpd']],
}

class {'apache': }
class {'apache::mod::php': }
class {'apache::mod::wsgi':}
# The apache module purges files it doesn't know about
# avoid this be referencing them here
file { '/etc/httpd/conf.d/openstack-dashboard.conf':}
file { '/etc/httpd/conf.d/rootredirect.conf':}
file { '/etc/httpd/conf.d/nagios.conf':}

service{['nagios']:
    ensure => running,
    enable => true,
    hasstatus => true,
}

firewall { '001 nagios incoming':
    proto    => 'tcp',
    dport    => ['80'],
    action   => 'accept',
}
