Exec { timeout => 300 }

$enable_auth = 'n'

class {"qpid::server":
    config_file => $::operatingsystem? {
        'Fedora' => '/etc/qpid/qpidd.conf',
        default  => '/etc/qpidd.conf',
        },
    auth => $enable_auth ? {
        'y'  => 'yes',
        default => 'no',
        },
    clustered => false,
    ssl_port      => '5671',
    ssl           => false,
    ssl_cert      => '',
    ssl_key       => '',
    ssl_database_password => '',
}
# Create firewall rules to allow only the hosts that need to connect
# to qpid - '5672'

$hosts = [ '10.16.139.38','10.16.139.39','10.16.139.10','10.16.139.31','10.16.139.36','10.16.139.37','10.16.139.4','10.16.139.5','10.16.139.6','10.16.139.7','10.16.139.3','10.16.139.8','10.16.139.9' ]

define add_allow_host {
    $source = $title ? {
        'ALL' => '0.0.0.0/0',
        default => $title,
    }
    firewall { "001 qpid - '5672' incoming ${title}":
        proto  => 'tcp',
        dport  => ['5672'],
        action => 'accept',
        source => $source,
    }
}

add_allow_host {$hosts:}
