Exec { timeout => 300 }


class {"keystone":
    admin_token => "cvdrhos4rhel65betatoken",
    sql_connection => "mysql://keystone_admin:badpass@10.16.139.2/keystone",
    token_format => "PKI",
}

class {"keystone::roles::admin":
    email => "test@test.com",
    password => "badpass",
    admin_tenant => "admin"
}

class {"keystone::endpoint":
    public_address  => "10.16.139.4",
    admin_address  => "10.16.139.4",
    internal_address  => "10.16.139.4",
}
# Create firewall rules to allow only the hosts that need to connect
# to keystone

$hosts = [ '10.16.139.38','10.16.139.39','10.16.139.10','10.16.139.31','10.16.139.36','10.16.139.37','10.16.139.4','10.16.139.5','10.16.139.6','10.16.139.7','10.16.139.8','10.16.139.9' ]

define add_allow_host {
    $source = $title ? {
        'ALL' => '0.0.0.0/0',
        default => $title,
    }
    firewall { "001 keystone incoming ${title}":
        proto  => 'tcp',
        dport  => ['5000', '35357'],
        action => 'accept',
        source => $source,
    }
}

add_allow_host {$hosts:}


class {"glance::keystone::auth":
    password => "badpass",
    public_address => "10.16.139.5",
    admin_address => "10.16.139.5",
    internal_address => "10.16.139.5",
}


class {"cinder::keystone::auth":
    password => "badpass",
    public_address => "10.16.139.6",
    admin_address => "10.16.139.6",
    internal_address => "10.16.139.6",
}

keystone_service { "${cinder::keystone::auth::auth_name}_v2":
    ensure      => present,
    type        => "${cinder::keystone::auth::service_type}v2",
    description => "Cinder Service v2",
}

keystone_endpoint { "${cinder::keystone::auth::region}/${cinder::keystone::auth::auth_name}_v2":
    ensure       => present,
    public_url   => "${cinder::keystone::auth::public_protocol}://${cinder::keystone::auth::public_address}:${cinder::keystone::auth::port}/v2/%(tenant_id)s",
    admin_url    => "http://${cinder::keystone::auth::admin_address}:${cinder::keystone::auth::port}/v2/%(tenant_id)s",
    internal_url => "http://${cinder::keystone::auth::internal_address}:${cinder::keystone::auth::port}/v2/%(tenant_id)s",
}


class {"nova::keystone::auth":
    password    => "badpass",
    public_address => "10.16.139.7",
    admin_address => "10.16.139.7",
    internal_address => "10.16.139.7",
    cinder => true,
}


class {"neutron::keystone::auth":
    password    => "badpass",
    public_address => "10.16.139.8",
    admin_address => "10.16.139.8",
    internal_address => "10.16.139.8",
}


if 'n' == 'y' {
    class {"heat::keystone::auth":
        password => "badpass",
        heat_public_address => "10.16.139.10",
        heat_admin_address => "10.16.139.10",
        heat_internal_address => "10.16.139.10",
        cfn_public_address => "10.16.139.10",
        cfn_admin_address => "10.16.139.10",
        cfn_internal_address => "10.16.139.10",
    }
} else {
    class {"heat::keystone::auth":
        password => "badpass",
        heat_public_address => "10.16.139.10",
        heat_admin_address => "10.16.139.10",
        heat_internal_address => "10.16.139.10",
        cfn_auth_name => undef,
    }
}


class { 'ceilometer::keystone::auth':
    password => 'badpass',
    public_address => "10.16.139.9",
    admin_address => "10.16.139.9",
    internal_address => "10.16.139.9",
}
