Exec { timeout => 300 }


package { 'mysql':
    ensure => 'present',
}

Package ['mysql'] -> Remote_database<||>
Package ['mysql'] -> Remote_database_user<||>
Package ['mysql'] -> Remote_database_grant<||>


remote_database { 'keystone':
    ensure      => 'present',
    charset     => 'latin1',
    db_host     => '10.16.139.2',
    db_user     => 'root',
    db_password => 'badpass',
    provider    => 'mysql',
}

remote_database_user { 'keystone_admin@%':
    password_hash => mysql_password('badpass' ),
    db_host       => '10.16.139.2',
    db_user       => 'root',
    db_password   => 'badpass',
    provider      => 'mysql',
    require       => Remote_database['keystone'],
}

remote_database_grant { 'keystone_admin@%/keystone':
    privileges  => "all",
    db_host     => '10.16.139.2',
    db_user     => 'root',
    db_password => 'badpass',
    provider    => 'mysql',
    require     => Remote_database_user['keystone_admin@%'],
}


remote_database { 'nova':
    ensure      => 'present',
    charset     => 'latin1',
    db_host     => '10.16.139.2',
    db_user     => 'root',
    db_password => 'badpass',
    provider    => 'mysql',
}

remote_database_user { 'nova@%':
    password_hash => mysql_password('badpass' ),
    db_host       => '10.16.139.2',
    db_user       => 'root',
    db_password   => 'badpass',
    provider      => 'mysql',
    require       => Remote_database['nova'],
}

remote_database_grant { 'nova@%/nova':
    privileges  => "all",
    db_host     => '10.16.139.2',
    db_user     => 'root',
    db_password => 'badpass',
    provider    => 'mysql',
    require     => Remote_database_user['nova@%'],
}


remote_database { 'cinder':
    ensure      => 'present',
    charset     => 'latin1',
    db_host     => '10.16.139.2',
    db_user     => 'root',
    db_password => 'badpass',
    provider    => 'mysql',
}

remote_database_user { 'cinder@%':
    password_hash => mysql_password('badpass'),
    db_host       => '10.16.139.2',
    db_user       => 'root',
    db_password   => 'badpass',
    provider      => 'mysql',
    require       => Remote_database['cinder'],
}

remote_database_grant { 'cinder@%/cinder':
    privileges  => "all",
    db_host     => '10.16.139.2',
    db_user     => 'root',
    db_password => 'badpass',
    provider    => 'mysql',
    require     => Remote_database_user['cinder@%'],
}


remote_database { 'glance':
    ensure      => 'present',
    charset     => 'latin1',
    db_host     => '10.16.139.2',
    db_user     => 'root',
    db_password => 'badpass',
    provider    => 'mysql',
}

remote_database_user { 'glance@%':
    password_hash => mysql_password('badpass' ),
    db_host       => '10.16.139.2',
    db_user       => 'root',
    db_password   => 'badpass',
    provider      => 'mysql',
    require       => Remote_database['glance'],
}

remote_database_grant { 'glance@%/glance':
    privileges  => "all",
    db_host     => '10.16.139.2',
    db_user     => 'root',
    db_password => 'badpass',
    provider    => 'mysql',
    require     => Remote_database_user['glance@%'],
}


remote_database { 'ovs_neutron':
    ensure      => 'present',
    charset     => 'latin1',
    db_host     => '10.16.139.2',
    db_user     => 'root',
    db_password => 'badpass',
    provider    => 'mysql',
}

remote_database_user { 'neutron@%':
    password_hash => mysql_password('badpass' ),
    db_host       => '10.16.139.2',
    db_user       => 'root',
    db_password   => 'badpass',
    provider      => 'mysql',
    require       => Remote_database['ovs_neutron'],
}

remote_database_grant { 'neutron@%/ovs_neutron':
    privileges  => "all",
    db_host     => '10.16.139.2',
    db_user     => 'root',
    db_password => 'badpass',
    provider    => 'mysql',
    require     => Remote_database_user['neutron@%'],
}


remote_database { 'heat':
    ensure      => 'present',
    charset     => 'latin1',
    db_host     => '10.16.139.2',
    db_user     => 'root',
    db_password => 'badpass',
    provider    => 'mysql',
}

remote_database_user { 'heat@%':
    password_hash => mysql_password('badpass'),
    db_host       => '10.16.139.2',
    db_user       => 'root',
    db_password   => 'badpass',
    provider      => 'mysql',
    require       => Remote_database['heat'],
}

remote_database_grant { 'heat@%/heat':
    privileges  => "all",
    db_host     => '10.16.139.2',
    db_user     => 'root',
    db_password => 'badpass',
    provider    => 'mysql',
    require     => Remote_database_user['heat@%'],
}

# Create firewall rules to allow only the hosts that need to connect
# to mysql

$hosts = [ '10.16.139.38','10.16.139.39','10.16.139.10','10.16.139.36','10.16.139.37','10.16.139.5','10.16.139.6','10.16.139.7','10.16.139.8' ]

define add_allow_host {
    $source = $title ? {
        'ALL' => '0.0.0.0/0',
        default => $title,
    }
    firewall { "001 mysql incoming ${title}":
        proto  => 'tcp',
        dport  => ['3306'],
        action => 'accept',
        source => $source,
    }
}

add_allow_host {$hosts:}
