Exec { timeout => 300 }


class {'cinder':
    rpc_backend    => 'cinder.openstack.common.rpc.impl_qpid',
    qpid_hostname  => "10.16.139.3",
    qpid_port       => '5672',
    qpid_protocol   => 'tcp',
    qpid_username  => 'guest',
    qpid_password  => 'guest',
    sql_connection => "mysql://cinder:badpass@10.16.139.2/cinder"
}

cinder_config {
    "DEFAULT/glance_host": value => "10.16.139.5";
}

package {'python-keystone':
    notify => Class['cinder::api'],
}

class {'cinder::api':
    keystone_password => 'badpass',
    keystone_tenant => "services",
    keystone_user => "cinder",
    keystone_auth_host => "10.16.139.4",
}

class {'cinder::scheduler':
}

class {'cinder::volume':
}

class {'cinder::volume::iscsi':
    iscsi_ip_address => '10.16.139.6'
}


package { 'glusterfs-fuse': ensure => present }

class { 'cinder::volume::glusterfs':
    glusterfs_shares => ['172.31.143.91:/OSTACKcinder'],
    require => Package['glusterfs-fuse'],
}

class { 'cinder::ceilometer': }
# Create firewall rules to allow only the hosts that need to connect
# to cinder

$hosts = [ '10.16.139.38','10.16.139.39','10.16.139.36','10.16.139.37' ]

define add_allow_host {
    $source = $title ? {
        'ALL' => '0.0.0.0/0',
        default => $title,
    }
    firewall { "001 cinder incoming ${title}":
        proto  => 'tcp',
        dport  => ['3260', '8776'],
        action => 'accept',
        source => $source,
    }
}

add_allow_host {$hosts:}
