Exec { timeout => 300 }


require 'keystone::python'
class {"nova::api":
    enabled => true,
    auth_host => "10.16.139.4",
    admin_password => "badpass",
    neutron_metadata_proxy_shared_secret => 'badpass'
}

Package<| title == 'nova-common' |> -> Class['nova::api']

firewall { '001 novaapi incoming':
    proto    => 'tcp',
    dport    => ['8773', '8774', '8775'],
    action   => 'accept',
}


# Ensure Firewall changes happen before nova services start
# preventing a clash with rules being set by nova-compute and nova-network
Firewall <| |> -> Class['nova']

nova_config{
    "DEFAULT/sql_connection": value => "mysql://nova:badpass@10.16.139.2/nova";
    "DEFAULT/metadata_host": value => "10.16.139.7";
}

class { "nova":
    glance_api_servers => "10.16.139.5:9292",
    qpid_hostname => "10.16.139.3",
    qpid_username => 'guest',
    qpid_password => 'guest',
    rpc_backend => 'nova.openstack.common.rpc.impl_qpid',
    verbose     => true,
    debug       => true,
    qpid_port       => '5672',
    qpid_protocol   => 'tcp'
}


class {"nova::network::neutron":
  neutron_admin_password => "badpass",
  neutron_auth_strategy => "keystone",
  neutron_url => "http://10.16.139.8:9696",
  neutron_admin_tenant_name => "services",
  neutron_admin_auth_url => "http://10.16.139.4:35357/v2.0",
}

class {"nova::compute::neutron":
  libvirt_vif_driver => "nova.virt.libvirt.vif.LibvirtHybridOVSBridgeDriver",
}
