Exec { timeout => 300 }

$neutron_db_host = '10.16.139.2'
$neutron_db_name = 'ovs_neutron'
$neutron_db_user = 'neutron'
$neutron_db_password = 'badpass'
$neutron_sql_connection = "mysql://${neutron_db_user}:${neutron_db_password}@${neutron_db_host}/${neutron_db_name}"

$neutron_user_password = 'badpass'

class { 'neutron':
  rpc_backend    => 'neutron.openstack.common.rpc.impl_qpid',
  qpid_hostname  => '10.16.139.3',
  qpid_username  => 'guest',
  qpid_password  => 'guest',
  core_plugin => 'neutron.plugins.openvswitch.ovs_neutron_plugin.OVSNeutronPluginV2',
  allow_overlapping_ips => true,
  verbose => true,
  qpid_port       => '5672',
  qpid_protocol   => 'tcp',
  service_plugins => ['neutron.services.loadbalancer.plugin.LoadBalancerPlugin'],
}

class { 'neutron::server':
  sql_connection => $neutron_sql_connection,
  connection => $neutron_sql_connection,
  auth_password => $neutron_user_password,
  auth_host => '10.16.139.4',
  enabled => true,
}

exec { 'neutron-db-manage upgrade':
  command     => 'neutron-db-manage --config-file /etc/neutron/neutron.conf --config-file /etc/neutron/plugin.ini upgrade head',
  path        => '/usr/bin',
  user        => 'neutron',
  logoutput   => 'on_failure',
  before      => Service['neutron-server'],
  require     => [Neutron_config['database/connection'], Neutron_config['DEFAULT/core_plugin']],
}
# Create firewall rules to allow only the hosts that need to connect
# to neutron

$hosts = [ '10.16.139.38','10.16.139.39','10.16.139.8','10.16.139.36','10.16.139.37' ]

define add_allow_host {
    $source = $title ? {
        'ALL' => '0.0.0.0/0',
        default => $title,
    }
    firewall { "001 neutron incoming ${title}":
        proto  => 'tcp',
        dport  => ['9696'],
        action => 'accept',
        source => $source,
    }
}

add_allow_host {$hosts:}

class { 'neutron::plugins::ovs':
  tenant_network_type => 'vlan',
  network_vlan_ranges => 'physint:1000:1020,physext',
}

class { 'neutron::agents::l3':
  interface_driver        => 'neutron.agent.linux.interface.OVSInterfaceDriver',
  external_network_bridge => '',
}

sysctl::value { 'net.ipv4.ip_forward':
  value => '1'
}


class { 'neutron::agents::ovs':
  bridge_mappings => ['physint:br-p3p1', 'physext:br-em2'],
}


vs_port { 'p3p1':
  bridge => 'br-p3p1',
  ensure => present
}



vs_port { 'em2':
  bridge => 'br-em2',
  ensure => present
}



class { 'neutron::agents::dhcp':
  interface_driver => 'neutron.agent.linux.interface.OVSInterfaceDriver',
}


class { 'neutron::agents::lbaas':
  interface_driver => 'neutron.agent.linux.interface.OVSInterfaceDriver',
  device_driver => 'neutron.services.loadbalancer.drivers.haproxy.namespace_driver.HaproxyNSDriver',
  user_group => 'haproxy',
}


class {'neutron::agents::metadata':
  auth_password => 'badpass',
  auth_url      => 'http://10.16.139.4:35357/v2.0',
  shared_secret => 'badpass',
  metadata_ip   => '10.16.139.7',
}

