Exec { timeout => 300 }

class { 'mongodb':
    enable_10gen => false,
    port         => '27017',
    before       => Class['ceilometer::db'],
    require      => Firewall['001 mongodb incoming localhost'],
}

firewall { '001 mongodb incoming localhost':
    proto       => 'tcp',
    dport       => ['27017'],
    iniface     => 'lo',
    #source      => 'localhost',
    #destination => 'localhost',
    action      => 'accept',
}

class { 'ceilometer':
    metering_secret => 'ceilometersecret',
    qpid_hostname   => '10.16.139.3',
    qpid_username   => 'guest',
    qpid_password   => 'guest',
    rpc_backend     => 'ceilometer.openstack.common.rpc.impl_qpid',
    verbose         => true,
    debug           => false,
    qpid_port       => '5672',
    qpid_protocol   => 'tcp'
}

class { 'ceilometer::db':
    database_connection => 'mongodb://localhost:27017/ceilometer',
    require             => Class['mongodb'],
}

class { 'ceilometer::collector':
    require => Class['mongodb'],
}

class { 'ceilometer::agent::auth':
    auth_url      => 'http://10.16.139.4:35357/v2.0',
    auth_password => 'badpass',
}

class { 'ceilometer::agent::central':
}

class { 'ceilometer::alarm::notifier':
}

class { 'ceilometer::alarm::evaluator':
}

class { 'ceilometer::api':
    keystone_host     => '10.16.139.4',
    keystone_password => 'badpass',
    require           => Class['mongodb'],
}
# Create firewall rules to allow only the hosts that need to connect
# to ceilometer-api

$hosts = [ 'ALL' ]

define add_allow_host {
    $source = $title ? {
        'ALL' => '0.0.0.0/0',
        default => $title,
    }
    firewall { "001 ceilometer-api incoming ${title}":
        proto  => 'tcp',
        dport  => ['8777'],
        action => 'accept',
        source => $source,
    }
}

add_allow_host {$hosts:}
